;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; THIS TEMPLATE FILE IS USED BY THE Multi Photo Quotes BUILDER tool
;
; ATTENTION: DO NOT MODIFY THIS FILE -- not only is it used for all build events
;  but it will be *OVERWRITTEN* when you upgrage Multi Photo Quotes.
;
; IF you wish to customize the template, make a new copy of this file with a different name,
;  and use your custom template when you build.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;








;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Include the variable defines for the screensaver (and mediapack if building that)
;
#include <InstallDefs_ScreenSaver.def>
#ifdef mediapack
	#include <InstallDefs_MediaPack.def>
#endif



; Decide on the screensaver install idname (usually SSIDNAME=SSFILENAME)
;  this includes a kludge fixup for the exception to the rule of no spaces
;  which i violated unthinkingly for MPQ
;
#ifndef SSIDNAME
	#if SSNAME == "MultiPhotoQuotes"
		#define public SSIDNAME "Multi Photo Quotes"
	#else
		#define public SSIDNAME SSNAME
	#endif
#endif



; this just points back to the installed Multi Photo Quotes directory
;  where the exe and other files are found we check its existence first
;  so user can override it in the .def file in case they want to build
;  in a deeper dir
;
#ifndef MPQEXEDIR
	#define public MPQEXEDIR "..\.."
#endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;








;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; OKAY NOW WE BUILD THE MEDIAPACK
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


; These items are OPTIONAL and we shouldnt link to them unless they are found
#define public filenamechm = curdir + "\InstallFiles_MpExtras\" + SSNAME + ".chm"
#define public filenameurl = curdir + "\InstallFiles_MpExtras\Visit Homepage.url.url"




[Files]
Source: {#curdir}\InstallFiles\*.*; DestDir: {app}\..\..\; Flags: ignoreversion recursesubdirs
Source: {#curdir}\InstallFiles_MpExtras\*.*; DestDir: {app}; Flags: ignoreversion recursesubdirs skipifsourcedoesntexist 



[Icons]
Name: {group}\Uninstall {#SSLONGNAME} media pack {#MPLONGNAME}; Filename: {app}\unins000.exe; WorkingDir: {app}

#if FileExists(filenamechm)
	Name: {group}\{#MPLONGNAME} Help; Filename: {app}\{#MPNAME}.chm; WorkingDir: {app}
#endif

#if FileExists(filenameurl)
	Name: {group}\{#MPLONGNAME} - Visit Homepage; Filename: {app}\Visit Homepage.url.url; WorkingDir: {app}
#endif



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



[Setup]
; important if we are to find the parent path of parent screensaver
UsePreviousAppDir=false
; basic default options
AllowNoIcons=true
ShowLanguageDialog=yes
MergeDuplicateFiles=false
AppendDefaultDirName=false
DisableFinishedPage=false
DirExistsWarning=false

AppId={#SSIDNAME}_{#MPNAME}
OutputBaseFilename={#SSNAME}_{#MPNAME}_Setup
AppCopyright={#MPCOMPANY}
VersionInfoCompany={#MPCOMPANY}
AppName={#SSLONGNAME} media pack "{#MPLONGNAME}"
AppVerName={#SSLONGNAME} media pack "{#MPLONGNAME}" {#MPVERSION}

DefaultGroupName={#SSLONGNAME}
DefaultDirName={code:CalcDefaultDirName}
OutputDir={#curdir}





[UninstallDelete]




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


[Run]

#if FileExists(filenameurl)
 Filename: {app}\Visit Homepage.url.url; WorkingDir: {app}; Description: Visit {#MPLONGNAME} Web Site; Flags: postinstall nowait shellexec unchecked
#endif


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



[Code]



// initialize install path to parent app -- anything to do here?
function InitializeSetup(): Boolean;
begin
  Result := True;
end;



function ParentAppIdPath(): String;
var
   sPrevPath: String;
begin
  sPrevPath := '';
  if not RegQueryStringValue(HKLM, 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{#SSIDNAME}_is1', 'InstallLocation', sPrevpath) then
    RegQueryStringValue(HKCU, 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{#SSIDNAME}_is1', 'InstallLocation', sPrevpath);
  Result := sPrevPath;
end;


// from http://www.vincenzo.net/isxkb/index.php?title=Upgrades
function IsUpgrade(): Boolean;
var
   sPrevPath: String;
begin
  sPrevPath := '';
  if not RegQueryStringValue(HKLM, 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{#emit SetupSetting("SSIDNAME")}_is1', 'UninstallString', sPrevpath) then
    RegQueryStringValue(HKCU, 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{#emit SetupSetting("SSIDNAME")}_is1', 'UninstallString', sPrevpath);
  Result := (sPrevPath <> '');
end;



function ShouldSkipPage(PageID: Integer): Boolean;
begin
  Result := False;
  if (ParentAppIdPath()<>'') then
  begin
		// skip install directory
    if PageID = wpSelectDir then Result := True;
		// do we want to skip programgroup? we should grab the old program group? for now we leave it
    // if PageID = wpSelectProgramGroup then Result := True;
  end;
end;



// based on http://www.vincenzo.net/isxkb/index.php?title=Checking_application_prerequisites
function IsMyPrerequisiteInstalled(): Boolean;
begin
		Result := (ParentAppIdPath() <> '');
		if not Result then begin
				MsgBox('ATTENTION!!'#13#13'The {#SSLONGNAME} screensaver was not found on your computer.'#13#13' Installation of this media pack should not continue unless'#13' you are absolutely sure that you know what you are doing.'#13#13'Press the Cancel button on the next page to terminate this installtion.', mbError, MB_OK);
				// if we want to let them continue anyway we can set Result:=true;
				Result := true;
		end
end;


function CalcDefaultDirName(tmp:String): String;
var
   sInstallPath: String;
begin
	sInstallPath := ParentAppIdPath();
  if (sInstallPath = '') then begin
		sInstallPath := ExpandConstant('{pf}') + '\{#SSNAME}';
  end;
	Result := sInstallPath + '\MediaPacks\{#MPNAME}';
end;





// ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




function NextButtonClick(CurPage: Integer): Boolean;
var
   sInstallPath: String;
begin
  Result := True;
  if CurPage = wpWelcome then begin
  	if not IsMyPrerequisiteInstalled() then begin
	    Result := False;
    	Exit;
		end;
	end;

  if CurPage = wpSelectDir then begin
		sInstallPath := ExpandConstant('{app}');
		// they have selected a custom directory now we want to verify its proper
    if Pos('\MediaPacks\{#MPNAME}',sInstallPath)=0 then begin
			sInstallPath := sInstallPath + '\MediaPacks\{#MPNAME}';
			//#SetSetupSetting('app',sInstallPath);
			//#SetSetupSetting('DefaultInstallDir',sInstallPath);
			//app=sInstallPath;
			WizardForm.DirEdit.Text := sInstallPath;
			MsgBox('The media pack must install into a subdirectory of the parent Screensaver.' + #13#10#13#10 + 'Changing install path to: '+#13#10+sInstallPath+#13#10#13#10+'Please check the install path before continuing..', mbError, MB_OK);
			Result := False;
			//CurPage:=wpSelectDir;

		end;
  end;

end;



// ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




[Messages]
	WelcomeLabel2=This will install the {#MPLONGNAME} media pack for {#SSLONGNAME} on your computer.%n%nNOTE 1: You *MUST* already have the {#SSLONGNAME} screensaver installed on your computer to proceed.
